diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/regmove.c gcc-4.1.1/gcc/regmove.c
--- gcc-4.1.1.orig/gcc/regmove.c	2005-08-25 07:44:09.000000000 +0100
+++ gcc-4.1.1/gcc/regmove.c	2006-08-10 09:56:05.000000000 +0100
@@ -970,35 +2885,36 @@ 		fprintf (regmove_dump_file,
 			 "Fixed operand of insn %d.\n",
 			  INSN_UID (insn));
 
-#ifdef AUTO_INC_DEC
-	      for (p = PREV_INSN (insn); p; p = PREV_INSN (p))
+	      if (AUTO_INC_DEC)
 		{
-		  if (LABEL_P (p)
-		      || JUMP_P (p))
-		    break;
-		  if (! INSN_P (p))
-		    continue;
-		  if (reg_overlap_mentioned_p (dst, PATTERN (p)))
+		  for (p = PREV_INSN (insn); p; p = PREV_INSN (p))
 		    {
-		      if (try_auto_increment (p, insn, 0, dst, newconst, 0))
-			return 1;
-		      break;
+		      if (LABEL_P (p)
+			  || JUMP_P (p))
+			break;
+		      if (! INSN_P (p))
+			continue;
+		      if (reg_overlap_mentioned_p (dst, PATTERN (p)))
+			{
+			  if (try_auto_increment (p, insn, 0, dst, newconst, 0))
+			    return 1;
+			  break;
+			}
 		    }
-		}
-	      for (p = NEXT_INSN (insn); p; p = NEXT_INSN (p))
-		{
-		  if (LABEL_P (p)
-		      || JUMP_P (p))
-		    break;
-		  if (! INSN_P (p))
-		    continue;
-		  if (reg_overlap_mentioned_p (dst, PATTERN (p)))
+		  for (p = NEXT_INSN (insn); p; p = NEXT_INSN (p))
 		    {
-		      try_auto_increment (p, insn, 0, dst, newconst, 1);
-		      break;
+		      if (LABEL_P (p)
+			  || JUMP_P (p))
+			break;
+		      if (! INSN_P (p))
+			continue;
+		      if (reg_overlap_mentioned_p (dst, PATTERN (p)))
+			{
+			  try_auto_increment (p, insn, 0, dst, newconst, 1);
+			  break;
+			}
 		    }
 		}
-#endif
 	      return 1;
 	    }
 	}
@@ -1040,7 +2956,7 @@    (or 0 if none should be output).  */
 void
 regmove_optimize (rtx f, int nregs, FILE *regmove_dump_file)
 {
-  int old_max_uid = get_max_uid ();
+  int old_max_uid;
   rtx insn;
   struct match match;
   int pass;
@@ -1057,6 +2973,13 @@   if (flag_non_call_exceptions)
      can suppress some optimizations in those zones.  */
   mark_flags_life_zones (discover_flags_reg ());
 
+  /* See the comment in front of REL_USE_HASH_SIZE what
+     this is about.  */
+  if (AUTO_INC_DEC && flag_regmove && flag_optimize_related_values)
+    optimize_related_values (nregs, regmove_dump_file);
+  /* That could have created new insns.  */
+  old_max_uid = get_max_uid ();
+
   regno_src_regno = xmalloc (sizeof *regno_src_regno * nregs);
   for (i = nregs; --i >= 0; ) regno_src_regno[i] = -1;
 
@@ -1999,6 +3922,8 @@   if (src_note)
       /* Move the death note for SRC from INSN to P.  */
       if (! overlap)
 	remove_note (insn, src_note);
+      if (find_reg_note (p, REG_INC, XEXP (src_note, 0)))
+	PUT_MODE (src_note, REG_UNUSED);
       XEXP (src_note, 1) = REG_NOTES (p);
       REG_NOTES (p) = src_note;
 
@@ -2540,3 +4465,4 @@ struct tree_opt_pass pass_stack_adjustme
   0                                     /* letter */
 };
 
+#include "gt-regmove.h"
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/rtlhooks.c gcc-4.1.1/gcc/rtlhooks.c
--- gcc-4.1.1.orig/gcc/rtlhooks.c	2005-06-25 03:02:01.000000000 +0100
+++ gcc-4.1.1/gcc/rtlhooks.c	2006-08-10 09:56:05.000000000 +0100
@@ -1,5 +1,6 @@
 /* Generic hooks for the RTL middle-end.
    Copyright (C) 2004, 2005 Free Software Foundation, Inc.
+   Copyright (c) 2006  STMicroelectronics.
 
 This file is part of GCC.
 
@@ -44,9 +45,12 @@   rtx result = gen_lowpart_common (mode,
 
   if (result)
     return result;
-  else if (REG_P (x))
+  /* If it's a REG, it must be a hard reg that's not valid in MODE.  */
+  else if (REG_P (x)
+	   /* Or we could have a subreg of a floating point value.  */
+	   || (GET_CODE (x) == SUBREG
+	       && FLOAT_MODE_P (GET_MODE (SUBREG_REG (x)))))
     {
-      /* Must be a hard reg that's not valid in MODE.  */
       result = gen_lowpart_common (mode, copy_to_reg (x));
       gcc_assert (result != 0);
       return result;
